#!/usr/bin/env python3
# Created By MrDude
# Arm2Hex - https://armconverter.com/
 
import hashlib
import os.path
from pathlib import Path
import sys
import struct

compkip = "files/FS.kip1"
kipname = "files/FS-dec.kip1"

if not Path(compkip).exists() or not os.path.isfile(compkip):
    print("ERROR " + compkip + " does not exist.")
    sys.exit()

if not Path(kipname).exists() or not os.path.isfile(kipname):
    print("ERROR " + kipname + " does not exist.")
    sys.exit()

from bitstring import ConstBitStream
# Can initialise from files, bytes, etc.
s = ConstBitStream(filename=kipname)
find = s.find('0x1e42b91fc14271')

# Search to Start of Frame 0 code on byte boundary
def atmosnow():
    if find:
        res = int(''.join(map(str, find)))
        newval = res / 8
        addpos = int(5) #byte position in find hex
        final = int(newval - addpos)
        final2 = int(final - 0x100)

        sha256_hash = hashlib.sha256()

        with open(compkip,"rb") as f:
            # Read and update hash string value in blocks of 4K
            for byte_block in iter(lambda: f.read(4096),b""):
                sha256_hash.update(byte_block)
            info = sha256_hash.hexdigest()
            info = info.upper()

        with open(kipname,"rb") as f:
            # Read original data
            f.seek(final)
            orig = struct.unpack('>I',f.read(4))[0]

        print("IPS patch address: 0x%X" % final)
        print("Hekate patch address: 0x%X" % final2)

        # Write IPS patch
        text_file = open(info + ".ips", "wb")
        hexval = hex(final)
        shorthex =  hexval.replace("0x", "")
        y = bytes.fromhex(str("50415443480" + shorthex + "00041F2003D5454F46")) #written ips patch
        text_file.write(y)
        text_file.close()

        # Write Hekate patch
        loader = ("[FS:" + info[:-48] + "]")
        patchnfo = (".nosigchk=0:0x%X:0x4:%X,1F2003D5" %(final2,orig))
        #print("\nAdd to Patches.ini")
        #print(loader)
        #print(patchnfo)
        txt = open(info + ".txt", "w")
        txt.write(loader + "\n" + patchnfo + "\n\n")
        txt.close()
    else:
        cantfind()        

def cantfind():
    print ("Can't find the byte pattern, unable to create an ips file :-(")
    sys.exit()    

atmosnow()
