#! /bin/bash
cd "$(dirname "${BASH_SOURCE[0]}")"

for f in ./firmware/*.nca; do
    ncasize="$(wc -c < "$f")"
    ncaname="$(basename "$f")"
    ncadirname="${ncaname%.*}"

    if [ $ncasize -lt 3145728 ] || [ $ncasize -gt 3550000 ]; then
        continue
    fi

    ./hactool -t nca -k ./keys.dat --disablekeywarns --romfsdir="./$ncadirname" "$f" &> /dev/null

    if [ ! -f "./$ncadirname/nx/package2" ]; then
        rm -rf "./$ncadirname" &> /dev/null
        continue
    fi

    echo Found package2 in NCA "$ncaname" with size "$ncasize"

    {
        ./hactool -t pk21 -k ./keys.dat --disablekeywarns --outdir="./$ncadirname/package2_ext" "./$ncadirname/nx/package2"
        ./hactool -t ini1 -k ./keys.dat --disablekeywarns --outdir="./$ncadirname/INI1_ext" "./$ncadirname/package2_ext/INI1.bin"
    } &> /dev/null

    rm -rf ./files &> /dev/null
    mkdir ./files

    mv -f "./$ncadirname/INI1_ext/FS.kip1" ./files/FS.kip1

    ./hactool -t kip1 -k ./keys.dat --disablekeywarns --uncompressed=./files/FS-dec.kip1 ./files/FS.kip1 &> /dev/null

    python3 MakeIPS.py

    rm -rf "./$ncadirname"
done

rm -rf ./files &> /dev/null

for f in ./*.ips; do
    if [ -f "$f" ]; then
        mkdir -p ./fusee/atmosphere/kip_patches/fs_patches
        mv -f ./*.ips ./fusee/atmosphere/kip_patches/fs_patches/
        break
    fi
done

for f in ./*.txt; do
    if [ -f "$f" ]; then
        mkdir -p ./hekate/bootloader
        cat ./*.txt > ./hekate/bootloader/patches.ini
        rm -f ./*.txt
        break
    fi
done

read -p "Press any key to finish ..."
